
mtype {
  FORK,
  BELL
}

chan bell = [1] of { mtype }

chan fork1 = [1] of { mtype }
chan fork2 = [1] of { mtype }
chan fork3 = [1] of { mtype }
chan fork4 = [1] of { mtype }
chan fork5 = [1] of { mtype }

proctype Philosopher(chan left; chan right) {
  bit has_left=0;
  bit has_right=0;
  bit has_bell=0;
  
  do
	:: !has_bell -> bell?BELL; has_bell=1;
					printf("Philosopher %d takes bell\n",_pid);
    :: has_bell & !has_left -> left?FORK;
		    has_left=1;
		    printf("Philosopher %d takes left fork\n",_pid);
    :: has_bell & !has_right -> right?FORK;
		     has_right=1;
		     printf("Philosopher %d takes right fork\n",_pid);
    :: else ->  printf("Philosopher %d is EATING\n",_pid);
				left!FORK;
				right!FORK;
				bell!BELL;
				has_left=0;
				has_right=0;
				has_bell=0;
  od;
}

init{
  fork1!FORK;
  fork2!FORK;
  fork3!FORK;
  fork4!FORK;
  fork5!FORK;
  bell!BELL;

  printf("The table is ready!\n");
  
  run Philosopher(fork1,fork2);
  run Philosopher(fork2,fork3);
  run Philosopher(fork3,fork4);
  run Philosopher(fork4,fork5);
  run Philosopher(fork5,fork1);
}
